#property indicator_chart_window //   
#property indicator_buffers 7
#property indicator_color1 Magenta // 
#property indicator_color3 Green // . . 
#property indicator_color4 Red // . . 
#property indicator_color5 Green // .  . 
#property indicator_color6 Red // .  . 
//  
extern double Sens=0; //   .
extern int FastMA=3; //  
extern int SlowMA=12; //  
extern int SmoothChannel=3; //  
extern int ShowChannel=4; //  1 -   , 2 -   
extern int ShowZigZag=0; //  1 -   , 2 -   
 bool countMode=1; // 0 -   , 1 -     
// .
double   ZZpeak[], // 
         ZZtrough[], // 
         ChTop[], // . . 
         ChBot[], // . . 
         ChTopS[], // .  . 
         ChBotS[], // .  . 
         MACD[]; // MACD
//  
double sens; // .  
double smch; // .  
bool dir; // 0- , 1 - 
double max,min; //  ., 
double top,bot; // , 
double topS0,botS0,topS1,botS1; // ,    (. .)
int jDn,jUp; //    
bool count=1; //    ; 1 -     
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   Comment(
      "Sensitivity (points) = ", Sens,"\n",
      "Fast MA period = ", FastMA,", ",
      "Slow MA period = ", SlowMA,"\n",
      "Smooth Channel period = ", SmoothChannel,"\n"
     );

   if(ShowZigZag<0 || ShowChannel<0) count=0;
   ShowZigZag=MathAbs(ShowZigZag); ShowChannel=MathAbs(ShowChannel);

   sens=Sens*Point;
   smch=2.0/(1+SmoothChannel);
//---- indicators
   SetIndexBuffer(0,ZZpeak);
   SetIndexEmptyValue(0,0.0);
   SetIndexLabel(0,"Peak");
   
   SetIndexBuffer(1,ZZtrough);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(1,"Trough");
   
   if(ShowZigZag>0) {
      SetIndexStyle(0,DRAW_ZIGZAG);
      SetIndexStyle(1,DRAW_ZIGZAG);
     }
   else {      
      SetIndexStyle(0,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
     }

   SetIndexBuffer(2,ChTop);
   SetIndexEmptyValue(2,0.0);
   SetIndexLabel(2,"ChTop");

   SetIndexBuffer(3,ChBot);
   SetIndexEmptyValue(3,0.0);
   SetIndexLabel(3,"ChBot");

   SetIndexBuffer(4,ChTopS);
   SetIndexEmptyValue(4,0.0);
   SetIndexLabel(4,"ChTopS");

   SetIndexBuffer(5,ChBotS);
   SetIndexEmptyValue(5,0.0);
   SetIndexLabel(5,"ChBotS");

   if(ShowChannel>0) {
      SetIndexStyle(2,DRAW_LINE,2);
      SetIndexStyle(3,DRAW_LINE,2);
      if(ShowChannel>2) {
         SetIndexStyle(4,DRAW_LINE);
         SetIndexStyle(5,DRAW_LINE);
        }
      else {      
         SetIndexStyle(4,DRAW_NONE);
         SetIndexStyle(5,DRAW_NONE);
        }
     }
   else {      
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
      SetIndexStyle(4,DRAW_NONE);
      SetIndexStyle(5,DRAW_NONE);
     }

   SetIndexBuffer(6,MACD);
   SetIndexStyle(6,DRAW_NONE);
   string _rsi="MACD";
   SetIndexLabel(6,_rsi);

//----
   IndicatorShortName("ZZ@MACD"); 

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int ic=IndicatorCounted();
   if(Bars-ic-1>1) ic=reinit();
   int limit=Bars-ic-1; // - 

   for(int i=limit; i>=0; i--) MACD[i]=iMACD(NULL,0,FastMA,SlowMA,1,0, 0,i);

   for(i=limit; i>0; i--)
     {
      double macd=MACD[i];
      jDn++; jUp++; //    

      bool up=macd> sens;
      bool dn=macd<-sens;

      if(dir) { //  
         if(up) { //    , 
            double l=High[i]*100;
            if(count) {for(int k=jUp; k>=0; k--) if(Low[i+k]<l) {int sh=i+k;l=Low[i+k];}}
            else {for(k=0; k<=jUp; k++) if(Low[i+k]<l) {sh=i+k;l=Low[i+k];}}
            bot=Low[sh]; //  = 
            if(ShowZigZag==1) ZZtrough[sh]=bot; else ZZtrough[i]=bot;
            if(ShowChannel==1 || ShowChannel==3) for(k=sh; k>i; k--) ChBot[k]=bot;
            botS1=botS0; botS0=smch*bot+(1-smch)*botS1;
            if(ShowChannel==3) for(k=sh; k>i; k--) ChBotS[k]=botS0;
            dir=0; //   
           }
        }
      else { //  
         if(dn) { //    , 
            double h=0;
            if(count) {for(k=jDn; k>=0; k--) if(High[i+k]>h) {sh=i+k; h=High[i+k];}}
            else {for(k=0; k<=jDn; k++) if(High[i+k]>h) {sh=i+k; h=High[i+k];}}
            top=High[sh];
            if(ShowZigZag==1) ZZpeak[sh]=top; else ZZpeak[i]=top;
            if(ShowChannel==1 || ShowChannel==3) for(k=sh; k>i; k--) ChTop[k]=top;
            topS1=topS0; topS0=smch*top+(1-smch)*topS1;
            if(ShowChannel==3) for(k=sh; k>i; k--) ChTopS[k]=topS0;
            dir=1; //   
           }
        }
      //  
      static bool upDisable,dnDisable;
      if(up && (!upDisable||countMode)) {
         jUp=-2; 
         upDisable=1; dnDisable=0;
        }
      if(dn && (!dnDisable||countMode)) {
         jDn=-2;
         dnDisable=1; upDisable=0;
        }

      for(k=0; k<2; k++) {ChTop[i-k]=top; ChBot[i-k]=bot; ChTopS[i-k]=topS0; ChBotS[i-k]=botS0;}
     }
        
   return(0);
  }


// -  
int reinit()
  {
   ArrayInitialize(ZZpeak,0.0);
   ArrayInitialize(ZZtrough,0.0);
   ArrayInitialize(ChTop,0.0);
   ArrayInitialize(ChBot,0.0);
   ArrayInitialize(MACD,0.0);
   dir=0;max=0;min=0;top=0;bot=0;jDn=0;jUp=0;
   topS0=0;botS0=0;topS1=0;botS1=0;
//   Comment("");
   return(0);
  }

void deinit() {Comment("");}